'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function registerHooks(collection, hooks) {
  if (!hooks) return collection;

  Object.keys(hooks).forEach(function (hook) {
    if (hook !== 'preInsert') collection[hook](hooks[hook]);else {
      // Add collection arg to preInsert
      collection[hook](function (data) {
        // eslint-disable-next-line babel/no-invalid-this
        return hooks[hook].call(this, data, collection);
      });
    }
  });
  return collection;
}

exports.default = {
  rxdb: true,
  prototypes: {
    RxDatabase: function RxDatabase(proto) {
      var prevCollection = proto.collection;
      Object.assign(proto, {
        collection: function () {
          var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(model) {
            for (var _len = arguments.length, other = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
              other[_key - 1] = arguments[_key];
            }

            var hooks, collection;
            return regeneratorRuntime.wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    hooks = model && model.options && model.options.hooks;
                    _context.next = 3;
                    return prevCollection.call(this, model, other);

                  case 3:
                    collection = _context.sent;
                    return _context.abrupt('return', registerHooks.call(this, collection, hooks));

                  case 5:
                  case 'end':
                    return _context.stop();
                }
              }
            }, _callee, this);
          }));

          function collection(_x) {
            return _ref.apply(this, arguments);
          }

          return collection;
        }()
      });
    },
    RxCollection: function RxCollection(proto) {
      var prevInMemory = proto.inMemory;
      Object.assign(proto, {
        inMemory: function () {
          var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
            for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
              args[_key2] = arguments[_key2];
            }

            var collection, hooks;
            return regeneratorRuntime.wrap(function _callee2$(_context2) {
              while (1) {
                switch (_context2.prev = _context2.next) {
                  case 0:
                    _context2.next = 2;
                    return prevInMemory.apply(this, args);

                  case 2:
                    collection = _context2.sent;
                    hooks = collection.options && collection.options.hooks;
                    return _context2.abrupt('return', registerHooks.call(this, collection, hooks));

                  case 5:
                  case 'end':
                    return _context2.stop();
                }
              }
            }, _callee2, this);
          }));

          function inMemory() {
            return _ref2.apply(this, arguments);
          }

          return inMemory;
        }()
      });
    }
  },
  overwritable: {},
  hooks: {}
};