'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.loglevels = exports.loglevel = undefined;

var _logger = require('./logger');

Object.defineProperty(exports, 'loglevel', {
  enumerable: true,
  get: function get() {
    return _logger.loglevel;
  }
});
Object.defineProperty(exports, 'loglevels', {
  enumerable: true,
  get: function get() {
    return _logger.loglevels;
  }
});
exports.default = register;

var _models = require('./models');

var _models2 = _interopRequireDefault(_models);

var _collections = require('./collections');

var _collections2 = _interopRequireDefault(_collections);

var _defaultValues = require('./default-values');

var _defaultValues2 = _interopRequireDefault(_defaultValues);

var _timestamps = require('./timestamps');

var _timestamps2 = _interopRequireDefault(_timestamps);

var _views = require('./views');

var _views2 = _interopRequireDefault(_views);

var _select = require('./select');

var _select2 = _interopRequireDefault(_select);

var _observables = require('./observables');

var _observables2 = _interopRequireDefault(_observables);

var _remove = require('./remove');

var _remove2 = _interopRequireDefault(_remove);

var _hooks = require('./hooks');

var _hooks2 = _interopRequireDefault(_hooks);

var _replication = require('./replication');

var _replication2 = _interopRequireDefault(_replication);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function register(RxDB) {
  RxDB.plugin(_models2.default);
  RxDB.plugin(_collections2.default);
  RxDB.plugin(_defaultValues2.default);
  RxDB.plugin(_timestamps2.default);
  RxDB.plugin(_views2.default);
  RxDB.plugin(_select2.default);
  RxDB.plugin(_observables2.default);
  RxDB.plugin(_remove2.default);
  RxDB.plugin(_hooks2.default);
  RxDB.plugin(_replication2.default);
}