'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

exports.default = parseProperties;

var _lodash = require('lodash.merge');

var _lodash2 = _interopRequireDefault(_lodash);

var _lodash3 = require('lodash.flattendeep');

var _lodash4 = _interopRequireDefault(_lodash3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function parseObj(obj) {
  return Object.entries(obj).reduce(function (acc, _ref) {
    var _ref2 = _slicedToArray(_ref, 2),
        key = _ref2[0],
        value = _ref2[1];

    if (!value) return acc;

    if (Array.isArray(value)) acc[key] = parseProperties(value);else if ((typeof value === 'undefined' ? 'undefined' : _typeof(value)) === 'object') acc[key] = parseObj(value);else if (typeof value === 'string') acc[key] = parseString(value);else acc[key] = {};

    return acc;
  }, {});
}

function parseString(str) {
  var all = str.split('.');
  var obj = {};
  var current = obj;
  all.forEach(function (key) {
    if (!current[key]) current[key] = {};
    current = current[key];
  });
  return obj;
}

function parseProperties(propertiesArr) {
  if (!Array.isArray(propertiesArr)) throw Error('invalid properties');
  propertiesArr = (0, _lodash4.default)(propertiesArr);

  var properties = {};
  propertiesArr.forEach(function (property) {
    switch (typeof property === 'undefined' ? 'undefined' : _typeof(property)) {
      case 'string':
        return properties = (0, _lodash2.default)(properties, parseString(property));
      case 'object':
        return properties = (0, _lodash2.default)(properties, parseObj(property));
      default:
        throw Error('invalid properties');
    }
  });

  return properties;
}