'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

exports.default = {
  rxdb: true,
  prototypes: {
    RxDatabase: function RxDatabase(proto) {
      var prevCollection = proto.collection;
      Object.assign(proto, {
        collection: function () {
          var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(model) {
            for (var _len = arguments.length, other = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
              other[_key - 1] = arguments[_key];
            }

            var timestamps, collection;
            return regeneratorRuntime.wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    timestamps = model && model.options && model.options.timestamps;
                    _context.next = 3;
                    return prevCollection.call(this, model, other);

                  case 3:
                    collection = _context.sent;

                    if (timestamps) {
                      _context.next = 6;
                      break;
                    }

                    return _context.abrupt('return', collection);

                  case 6:

                    // Register hooks
                    collection.preInsert(function (data) {
                      var now = new Date().toISOString();
                      if (!data.createdAt) data.createdAt = now;
                      if (!data.updatedAt) data.updatedAt = now;

                      return data;
                    });

                    collection.preSave(function (data, doc) {
                      data.updatedAt = new Date().toISOString();
                      return data;
                    });

                    return _context.abrupt('return', collection);

                  case 9:
                  case 'end':
                    return _context.stop();
                }
              }
            }, _callee, this);
          }));

          function collection(_x) {
            return _ref.apply(this, arguments);
          }

          return collection;
        }()
      });
    }
  },
  overwritable: {},
  hooks: {
    preCreateRxCollection: function preCreateRxCollection(model) {
      if (!model.schema || !model.schema.properties) {
        throw Error('RxCollection(s) must have a a "schema" property, with a "properties" key');
      }

      var timestamps = model && model.options && model.options.timestamps;
      if (!timestamps) return model;

      // Set schema
      model.schema.properties.createdAt = model.schema.properties.createdAt || {
        format: 'date-time',
        type: 'string'
      };
      model.schema.properties.updatedAt = model.schema.properties.updatedAt || {
        format: 'date-time',
        type: 'string'
      };

      model.schema.required = (model.schema.required || []).concat(['createdAt', 'updatedAt']);

      return model;
    }
  }
};