'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

exports.default = RxDocument;

var _v = require('uuid/v4');

var _v2 = _interopRequireDefault(_v);

var _operators = require('rxjs/operators');

var _createSubject = require('./create-subject');

var _createSubject2 = _interopRequireDefault(_createSubject);

var _constants = require('./constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function RxDocument(proto, viewsArr) {
  // Define getters for views

  Object.defineProperties(proto, viewsArr.reduce(function (acc, _ref) {
    var _ref2 = _slicedToArray(_ref, 2),
        key = _ref2[0],
        _get = _ref2[1].get;

    acc[key] = {
      get: function get() {
        var ans = this[_constants.OBSERVABLES_SYMBOL][key];
        if (ans) return ans;

        var getObs = _get.bind(this);
        ans = this[_constants.OBSERVABLES_SYMBOL][key] = createView(getObs);
        return ans;
      },

      enumerable: true
    };
    return acc;
  }, {}));

  Object.assign(proto, _defineProperty({}, _constants.ENSURE_SYMBOL, function ensure(propertyNames) {
    var _this = this;

    if (!propertyNames.length) propertyNames = this.collection._views;

    var unensureFns = [];
    propertyNames.forEach(function (property) {
      unensureFns.push(_this[property][_constants.ENSURE_SYMBOL]());
    });

    function unensure() {
      unensureFns.forEach(function (fn) {
        return fn();
      });
    }
    return unensure;
  }));
}

function createView(getObs) {
  var _Object$definePropert;

  var obj = {};

  var ensuredIds = {};
  var ensured = false;
  var observable = void 0;
  var value = void 0;
  Object.defineProperties(obj, (_Object$definePropert = {}, _defineProperty(_Object$definePropert, _constants.ENSURE_SYMBOL, {
    value: function ensure() {
      var id = (0, _v2.default)();
      ensured = true;
      ensuredIds[id] = true;
      return function unensure() {
        ensured = null;
        delete ensuredIds[id];
      };
    },
    enumerable: true
  }), _defineProperty(_Object$definePropert, 'ensured', {
    get: function get() {
      if (ensured === null) ensured = Boolean(Object.keys(ensuredIds).length);
      return ensured;
    },

    enumerable: true
  }), _defineProperty(_Object$definePropert, '$', {
    get: function get() {
      if (!observable) {
        var obs = getObs().pipe((0, _operators.tap)(function (res) {
          return obj.ensured && (value = res);
        }));
        observable = (0, _createSubject2.default)(obs, { keepOpenCheck: function keepOpenCheck() {
            return obj.ensured;
          } });
      }
      return observable;
    },

    enumerable: true
  }), _defineProperty(_Object$definePropert, 'promise', {
    get: function get() {
      return obj.$.pipe((0, _operators.take)(1)).toPromise();
    },

    enumerable: true
  }), _defineProperty(_Object$definePropert, 'exec', {
    value: function exec() {
      return getObs().pipe((0, _operators.take)(1)).toPromise();
    },
    enumerable: true
  }), _defineProperty(_Object$definePropert, 'value', {
    get: function get() {
      if (!obj.ensured) {
        throw Error('Tried to get an view value for RxDocument not part of an ensure$() query');
      }
      return value;
    },

    enumerable: true
  }), _Object$definePropert));

  return obj;
}